
-- rgf, 2007-07-15

xContext = UNO.connect()  -- connect to server and retrieve the XContext object
-- XMcf = xContext~getServiceManager   -- retrieve XMultiComponentFactory

oDesktop         = UNO.createDesktop(xContext)  -- get the UNO Desktop service object
xComponentLoader = oDesktop~XDesktop~XComponentLoader  -- get componentLoader
                                                       -- interface
/* open the blank *.odc - file */
url = "private:factory/scalc"
xCalcComponent = xComponentLoader~loadComponentFromURL(url, "_blank", 0, .UNO~noProps)


/* get first sheet in spreadsheet */
xSheet = xCalcComponent~XSpreadSheetDocument~getSheets~XIndexAccess~getByIndex(0) ~XSpreadSheet

oBrowseNodeFactory = xContext~getValueByName("/singletons/com.sun.star.script.browse.theBrowseNodeFactory")
iViewType = bsf.getConstant("com.sun.star.script.browse.BrowseNodeFactoryViewTypes", "MACROORGANIZER")

aMasterProviders = oBrowseNodeFactory~XBrowseNodeFactory~createView(iViewType)~ChildNodes

iLevel = 0
.local~iRow = 0      -- save in .local environment, makes it globally accessible
do oMasterProvider over aMasterProviders
   call uno.setCell xSheet, iLevel, .iRow, oMasterProvider~name
say "Master-name:" "   "~copies(iLevel) pp(oMasterProvider~name)
   call printChildNodes xSheet, oMasterProvider, iLevel+1
  .local~iRow = .iRow+1
end

exit


printChildNodes: procedure
   use arg xSheet, oParent, iLevel
-- say ppd( oParent~uno.getDefinition )

  do oChild over oParent~XBrowseNode~childNodes
    .local~iRow = .iRow+1
    call uno.setCell xSheet, iLevel, .iRow, oChild~name
say "oChild~name:" "   "~copies(iLevel) pp(oChild~name)
    xProps=oChild~XPropertySetInfo
    if .nil<>xProps then
    do
      if xProps~hasPropertyByName("URI") Then
         call uno.setCell xSheet, iLevel+1, .iRow, xProps~getPropertyByName("URI")
    end

    If hasChildNodes(oChild) Then
      call PrintChildNodes xSheet, oChild, iLevel+1
  end
  return


::requires uno.cls      -- get ooRexx support for OOo


::routine hasChildNodes -- there may be some exceptions (e.g. "exceptions.AttributeError")
  use arg oChild

  signal on any         -- any condition will cause jump to "ANY:" label
  return oChild~hasChildNodes

any:
  -- pause
  return .false



/*
REM  *****  BASIC  *****

Dim oSheet As Object
Dim iRow As Integer

sub BrowseMacrosExample
  oDoc = StarDesktop.loadComponentFromUrl( _
    "private:factory/scalc","_default",0,Array())
  oSheet = oDoc.Sheets(0)

  oBrowseNodeFactory = GetDefaultContext.getValueByName( _
    "/singletons/com.sun.star.script.browse.theBrowseNodeFactory")

  iViewType = _
    com.sun.star.script.browse.BrowseNodeFactoryViewTypes.MACROORGANIZER
  aMasterProviders() = oBrowseNodeFactory.createView(iViewType).ChildNodes()

  iLevel = 0
  iRow = 0
  For Each oMasterProvider in aMasterProviders()
    oSheet.getCellByPosition(iLevel, iRow).String = oMasterProvider.Name
    PrintChildNodes(oMasterProvider, iLevel+1)
    iRow = iRow+1
  Next oMasterProvider

end sub


Sub PrintChildNodes(oParent, iLevel)
On error resume next
  For Each oChild In oParent.ChildNodes()
    iRow = iRow+1
    oSheet.getCellByPosition(iLevel, iRow).String = oChild.Name
    If HasUnoInterfaces(oChild, "com.sun.star.beans.XPropertySet") Then
      If oChild.PropertySetInfo.hasPropertyByName("URI") Then
        oSheet.getCellByPosition(iLevel+1, iRow).String = oChild.URI
      End If
    End If
    If oChild.hasChildNodes() Then
      PrintChildNodes(oChild, iLevel+1)
    End If
  Next oChild

End Sub

*/
